<?php
/**
 * Clase Base FN para BaseCrCreditoPagoFN
 *
 * @package    
 * @subpackage BaseCrCreditoPagoFN
 * @author     Willy
 * @version    SVN:: BaseCrCreditoPagoFN.class.php,v 1.1 2013-01-04 11:11:51 william.taype Exp $
 */
class BaseCrCreditoPagoFN extends CrCreditoPagoBN
{
  private static $fieldNames = array (
    'Idpago'=>'idpago', 'Tipopago'=>'tipopago', 'Fechacuota'=>'fechacuota','Fechatrx'=>'fechatrx', 'Montopago'=>'montopago', 'Fechacreacion'=>'fechacreacion', 'Usauriocreacion'=>'usuariocreacion', 'Eliminado'=>'eliminado', 'Fechaeliminado'=>'fechaeliminado', 'Usuarioeliminado'=>'usuarioeliminado', 'Numerorecibo'=>'numerorecibo', 'Banco'=>'banco', 'Numerooperacion'=>'numerooperacion', 'Fechaoperacion'=>'fechaoperacion', 'Observacion'=>'observacion', 'Idcuota'=>'idcuota', 'Idcreditocrono'=>'idcreditocrono', 'Idcolaborador'=>'idcolaborador'  
  );

  public function select()
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();

      $con = Conexion::getConexion();
      $sql = "SELECT idpago, tipopago, fechatrx, montopago, fechacreacion, usuariocreacion, eliminado, fechaeliminado, usuarioeliminado, numerorecibo, banco, numerooperacion, fechaoperacion, observacion, idcuota, idcreditocrono, idcolaborador FROM cr_credito_pago WHERE 1 ".$where." ".$orden."  LIMIT ".$limitInf.",".$tamPag;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function selectNumRows()
  {
    try
    {
      $where = $this->buildConsult();

      $con = Conexion::getConexion();
      $sql = "SELECT idpago, tipopago, fechatrx, montopago, fechacreacion, usuariocreacion, eliminado, fechaeliminado, usuarioeliminado, numerorecibo, banco, numerooperacion, fechaoperacion, observacion, idcuota, idcreditocrono, idcolaborador FROM cr_credito_pago WHERE 1 ".$where;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      
      return $num_rows;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildConsult()
  {
    try
    {
      $where = "";

      if($this->getIdpago()){ $where .= " AND idpago = '".$this->getIdpago()."'"; }
      if($this->getTipopago()){ $where .= " AND tipopago = '".$this->getTipopago()."'"; }
      if($this->getFechatrx()){ $where .= " AND fechatrx = '".$this->getFechatrx()."'"; }
      if($this->getFechaInicio()){ $where .= " AND fechatrx >= '".$this->getFechaInicio()."'"; }
      if($this->getFechaFinal()){ $where .= " AND fechatrx >= '".$this->getFechaFinal()."'"; }
      if($this->getMontopago()){ $where .= " AND montopago = '".$this->getMontopago()."'"; }
      if($this->getFechacreacion()){ $where .= " AND fechacreacion = '".$this->getFechacreacion()."'"; }
      if($this->getUsauriocreacion()){ $where .= " AND usuariocreacion = '".$this->getUsauriocreacion()."'"; }
      if($this->getEliminado()){ $where .= " AND eliminado = '".$this->getEliminado()."'"; }
      if($this->getFechaeliminado()){ $where .= " AND fechaeliminado = '".$this->getFechaeliminado()."'"; }
      if($this->getUsuarioeliminado()){ $where .= " AND usuarioeliminado = '".$this->getUsuarioeliminado()."'"; }
      if($this->getNumerorecibo()){ $where .= " AND numerorecibo = '".$this->getNumerorecibo()."'"; }
      if($this->getBanco()){ $where .= " AND banco = '".$this->getBanco()."'"; }
      if($this->getNumerooperacion()){ $where .= " AND numerooperacion = '".$this->getNumerooperacion()."'"; }
      if($this->getFechaoperacion()){ $where .= " AND fechaoperacion = '".$this->getFechaoperacion()."'"; }
      if($this->getObservacion()){ $where .= " AND observacion = '".$this->getObservacion()."'"; }
      if($this->getIdcuota()){ $where .= " AND idcuota = '".$this->getIdcuota()."'"; }
      if($this->getIdcreditocrono()){ $where .= " AND idcreditocrono = '".$this->getIdcreditocrono()."'"; }
      if($this->getIdcolaborador()){ $where .= " AND idcolaborador = '".$this->getIdcolaborador()."'"; }
      return $where;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildOrderByField()
  {
    try
    {
      $order_by = "";

      if(property_exists($this,'sortCampos')){
      if($this->sortCampos != ""){
        $a_valCampos = explode(";", $this->sortCampos);
        $a_valtype   = explode(";", $this->sortType);
        $order_by = " ORDER BY ";
        $a_order = array();
        foreach ($a_valCampos as $key => $val){
          $sTmpOrder = "";
          if(array_key_exists($val, self::$fieldNames)){
            $sTmpOrder .= self::$fieldNames[$val];
            switch ($a_valtype[$key]){
              case 1: $sTmpOrder .= " ASC"; break;
              case 2: $sTmpOrder .= " DESC"; break;
            }
            $a_order[] = $sTmpOrder;
          }
        }
        $order_by .= implode(", ", $a_order);
      }
      }
      return $order_by;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* B�squeda del registro por la llave primaria */
  public function selectByPK()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT idpago, tipopago, fechatrx, montopago, fechacreacion, usuariocreacion, eliminado, fechaeliminado, usuarioeliminado, numerorecibo, banco, numerooperacion, fechaoperacion, observacion, idcuota, idcreditocrono, idcolaborador FROM cr_credito_pago WHERE 1 AND idpago='".$this->getIdpago()."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      

      return $o_Propel?$this->insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }
  
  public function listarPagos($idcolaborador,$fecha,$moneda){
  	 $con = Conexion::getConexion();
  	 $sql = "
  	 		SELECT  banco,tipopago,sum(montopago) as suma
  	 		FROM cr_credito_pago 
  	 		LEFT JOIN cr_credito_crono on cr_credito_crono.idcreditocrono = cr_credito_pago.idcreditocrono
  	 		WHERE 1 
  	 			AND cr_credito_pago.idcolaborador='".$idcolaborador."'
  	 			AND cr_credito_pago.fechatrx='".$fecha."'
  	 			AND moneda ='".$moneda."'
  	 		GROUP BY banco,tipopago
  	 		; ";
  	  //echo "--".$sql."----";	
  	  $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp['pago'] = $o_valor->suma;
          $a_tmp['tipo'] = 'HI';
          $a_tmp['tipopago'] = $o_valor->tipopago;
          $a_tmp['banco'] = $o_valor->banco;
          $a_tmpt[] = $a_tmp;
        }
      }
      /*
       $sql = "
  	 		SELECT  banco,tipo,cr_prestamo_interespago.tipopago as tipopago,sum(montopago) as suma
  	 		FROM cr_prestamo_interespago  
  	 		LEFT JOIN cr_prestamo_interes  on cr_prestamo_interes.idprestamointeres = cr_prestamo_interespago.idprestamo
  	 		WHERE 1 
  	 			AND cr_prestamo_interespago.idcolaborador='".$idcolaborador."'
  	 			AND cr_prestamo_interespago.fechapago='".$fecha."'
  	 			AND moneda ='".$moneda."'
  	 			and cr_prestamo_interespago.eliminado = '-1'
  	 		GROUP BY banco,tipo,tipopago
  	 		; ";
  	 // echo "--".$sql."----";	
  	  $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
     
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp['pago'] = $o_valor->suma;
          $a_tmp['tipo'] = $o_valor->tipo;
          $a_tmp['tipopago'] = $o_valor->tipopago;
          $a_tmp['banco'] = $o_valor->banco;
          $a_tmpt[] = $a_tmp;
        }
      }
      */
  	 return $a_tmpt;
  }
 
  
  
  
  /* Devuelve un objeto con m�todos de acceso */
  public function insertObjectBN($o_propel){
    $o_BaseCrCreditoPagoFN = new BaseCrCreditoPagoFN();
    $o_BaseCrCreditoPagoFN->setIdpago($o_propel->idpago);
    $o_BaseCrCreditoPagoFN->setTipopago($o_propel->tipopago);
    $o_BaseCrCreditoPagoFN->setFechatrx($o_propel->fechatrx);
    $o_BaseCrCreditoPagoFN->setMontopago($o_propel->montopago);
    $o_BaseCrCreditoPagoFN->setFechacreacion($o_propel->fechacreacion);
    $o_BaseCrCreditoPagoFN->setUsauriocreacion($o_propel->usuariocreacion);
    $o_BaseCrCreditoPagoFN->setEliminado($o_propel->eliminado);
    $o_BaseCrCreditoPagoFN->setFechaeliminado($o_propel->fechaeliminado);
    $o_BaseCrCreditoPagoFN->setUsuarioeliminado($o_propel->usuarioeliminado);
    $o_BaseCrCreditoPagoFN->setNumerorecibo($o_propel->numerorecibo);
    $o_BaseCrCreditoPagoFN->setBanco($o_propel->banco);
    $o_BaseCrCreditoPagoFN->setNumerooperacion($o_propel->numerooperacion);
    $o_BaseCrCreditoPagoFN->setFechaoperacion($o_propel->fechaoperacion);
    $o_BaseCrCreditoPagoFN->setObservacion($o_propel->observacion);
    $o_BaseCrCreditoPagoFN->setIdcuota($o_propel->idcuota);
    $o_BaseCrCreditoPagoFN->setIdcreditocrono($o_propel->idcreditocrono);
    $o_BaseCrCreditoPagoFN->setIdcolaborador($o_propel->idcolaborador);
    return $o_BaseCrCreditoPagoFN;
  }
}